set term !! ;

create procedure AddEnumValue(EnumName varchar(255), EnumVal integer, ValName varchar(255))
as
declare variable EnumID integer;
begin
  select ID from Enums where Name = :EnumName into :EnumID;

  if (:EnumID is not null) then
  begin
    if (exists (select Id from EnumValues where (EnumRef = :EnumID)and(Val = :EnumVal) )) then
      Update EnumValues ev set
        ev.Name = :ValName
      where (ev.EnumRef = :EnumID)and(ev.Val = :EnumVal);
    else
      insert into EnumValues(EnumRef, Val, Name) values (:EnumID, :EnumVal, :ValName);
  end
end
!!


execute procedure AddEnumValue('', 9, '      ,   12  93   44-') !!
execute procedure AddEnumValue('', 26, '      ,   12  93   44-') !!

drop procedure AddEnumValue
!!

commit work
!!

set term ; !!